VTK: vtkKMeansDistanceFunctor Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkKMeansDistanceFunctor Class Reference

measure distance from k-means cluster centers More...

`#include <vtkKMeansDistanceFunctor.h>`

Inheritance diagram for vtkKMeansDistanceFunctor:
[legend]
Collaboration diagram for vtkKMeansDistanceFunctor:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkKMeansDistanceFunctor * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual vtkVariantArray * | GetEmptyTuple (vtkIdType dimension)
| Return an empty tuple. More...
virtual void | operator() (double &, vtkVariantArray *, vtkVariantArray *)
| Compute the distance from one observation to another, returning the distance in the first argument. More...
virtual void | PairwiseUpdate (vtkTable *clusterCenters, vtkIdType row, vtkVariantArray *data, vtkIdType dataCardinality, vtkIdType totalCardinality)
| This is called once per observation per run per iteration in order to assign the observation to its nearest cluster center after the distance functor has been evaluated for all the cluster centers. More...
virtual void | PerturbElement (vtkTable *, vtkTable *, vtkIdType, vtkIdType, vtkIdType, double)
| When a cluster center (1) has no observations that are closer to it than other cluster centers or (2) has exactly the same coordinates as another cluster center, its coordinates should be perturbed. More...
virtual void * | AllocateElementArray (vtkIdType size)
| Allocate an array large enough to hold size coordinates and return a void pointer to this array. More...
virtual void | DeallocateElementArray (void *)
| Free an array allocated with AllocateElementArray. More...
virtual vtkAbstractArray * | CreateCoordinateArray ()
| Return a vtkAbstractArray capable of holding cluster center coordinates. More...
virtual void | PackElements (vtkTable *curTable, void *vElements)
| Pack the cluster center coordinates in vElements into columns of curTable. More...
virtual int | GetDataType ()
| Return the data type used to store cluster center coordinates. More...
virtual void | UnPackElements (vtkTable *curTable, vtkTable *newTable, void *vLocalElements, void *vGlobalElements, int np)
| Unpack the cluster center coordinates in vElements into columns of curTable. More...
virtual void | UnPackElements (vtkTable *curTable, void *vLocalElements, vtkIdType numRows, vtkIdType numCols)
| Unpack the cluster center coordinates in vElements into columns of curTable. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkKMeansDistanceFunctor * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkKMeansDistanceFunctor * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkKMeansDistanceFunctor ()
| ~vtkKMeansDistanceFunctor () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkVariantArray * | EmptyTuple
vtkTable * | CenterUpdates
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

measure distance from k-means cluster centers

This is an abstract class (with a default concrete subclass) that implements algorithms used by the vtkKMeansStatistics filter that rely on a distance metric. If you wish to use a non-Euclidean distance metric (this could include working with strings that do not have a Euclidean distance metric, implementing k-mediods, or trying distance metrics in norms other than L2), you should subclass vtkKMeansDistanceFunctor.

Definition at line 26 of file vtkKMeansDistanceFunctor.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkKMeansDistanceFunctor::Superclass

Definition at line 30 of file vtkKMeansDistanceFunctor.h.

## Constructor & Destructor Documentation

## ◆ vtkKMeansDistanceFunctor()

vtkKMeansDistanceFunctor::vtkKMeansDistanceFunctor | ( |  | ) |
| protected

## ◆ ~vtkKMeansDistanceFunctor()

vtkKMeansDistanceFunctor::~vtkKMeansDistanceFunctor | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkKMeansDistanceFunctor* vtkKMeansDistanceFunctor::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkKMeansDistanceFunctor::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkKMeansDistanceFunctor::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkKMeansDistanceFunctorCalculator.

## ◆ SafeDownCast()

static vtkKMeansDistanceFunctor* vtkKMeansDistanceFunctor::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkKMeansDistanceFunctor::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkKMeansDistanceFunctorCalculator.

## ◆ NewInstance()

vtkKMeansDistanceFunctor* vtkKMeansDistanceFunctor::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkKMeansDistanceFunctor::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkKMeansDistanceFunctorCalculator.

## ◆ GetEmptyTuple()

virtual vtkVariantArray* vtkKMeansDistanceFunctor::GetEmptyTuple | ( | vtkIdType | dimension | ) |
| virtual

Return an empty tuple.

These values are used as cluster center coordinates when no initial cluster centers are specified.

## ◆ operator()()

virtual void vtkKMeansDistanceFunctor::operator() | ( | double & | ,
|  | vtkVariantArray * | ,
|  | vtkVariantArray * |
| ) |  |
| virtual

Compute the distance from one observation to another, returning the distance in the first argument.

Reimplemented in vtkKMeansDistanceFunctorCalculator.

## ◆ PairwiseUpdate()

virtual void vtkKMeansDistanceFunctor::PairwiseUpdate | ( | vtkTable * | clusterCenters,
|  | vtkIdType | row,
|  | vtkVariantArray * | data,
|  | vtkIdType | dataCardinality,
|  | vtkIdType | totalCardinality
| ) |  |
| virtual

This is called once per observation per run per iteration in order to assign the observation to its nearest cluster center after the distance functor has been evaluated for all the cluster centers.

The distance functor is responsible for incrementally updating the cluster centers to account for the assignment.

## ◆ PerturbElement()

virtual void vtkKMeansDistanceFunctor::PerturbElement | ( | vtkTable * | ,
|  | vtkTable * | ,
|  | vtkIdType | ,
|  | vtkIdType | ,
|  | vtkIdType | ,
|  | double |
| ) |  |
| virtual

When a cluster center (1) has no observations that are closer to it than other cluster centers or (2) has exactly the same coordinates as another cluster center, its coordinates should be perturbed.

This function should perform that perturbation.

Since perturbation relies on a distance metric, this function is the responsibility of the distance functor.

## ◆ AllocateElementArray()

virtual void* vtkKMeansDistanceFunctor::AllocateElementArray | ( | vtkIdType | size | ) |
| virtual

Allocate an array large enough to hold size coordinates and return a void pointer to this array.

This is used by vtkPKMeansStatistics to send (receive) cluster center coordinates to (from) other processes.

## ◆ DeallocateElementArray()

virtual void vtkKMeansDistanceFunctor::DeallocateElementArray | ( | void * |  | ) |
| virtual

Free an array allocated with AllocateElementArray.

## ◆ CreateCoordinateArray()

virtual vtkAbstractArray* vtkKMeansDistanceFunctor::CreateCoordinateArray | ( |  | ) |
| virtual

Return a vtkAbstractArray capable of holding cluster center coordinates.

This is used by vtkPKMeansStatistics to hold cluster center coordinates sent to (received from) other processes.

## ◆ PackElements()

virtual void vtkKMeansDistanceFunctor::PackElements | ( | vtkTable * | curTable,
|  | void * | vElements
| ) |  |
| virtual

Pack the cluster center coordinates in vElements into columns of curTable.

This code may assume that the columns in curTable are all of the type returned by GetNewVTKArray().

## ◆ UnPackElements() [1/2]

virtual void vtkKMeansDistanceFunctor::UnPackElements | ( | vtkTable * | curTable,
|  | vtkTable * | newTable,
|  | void * | vLocalElements,
|  | void * | vGlobalElements,
|  | int | np
| ) |  |
| virtual

Unpack the cluster center coordinates in vElements into columns of curTable.

This code may assume that the columns in curTable are all of the type returned by GetNewVTKArray().

## ◆ UnPackElements() [2/2]

virtual void vtkKMeansDistanceFunctor::UnPackElements | ( | vtkTable * | curTable,
|  | void * | vLocalElements,
|  | vtkIdType | numRows,
|  | vtkIdType | numCols
| ) |  |
| virtual

Unpack the cluster center coordinates in vElements into columns of curTable.

This code may assume that the columns in curTable are all of the type returned by GetNewVTKArray().

## ◆ GetDataType()

virtual int vtkKMeansDistanceFunctor::GetDataType | ( |  | ) |
| virtual

Return the data type used to store cluster center coordinates.

## Member Data Documentation

## ◆ EmptyTuple

vtkVariantArray* vtkKMeansDistanceFunctor::EmptyTuple
| protected

Definition at line 113 of file vtkKMeansDistanceFunctor.h.

## ◆ CenterUpdates

vtkTable* vtkKMeansDistanceFunctor::CenterUpdates
| protected

Definition at line 115 of file vtkKMeansDistanceFunctor.h.

The documentation for this class was generated from the following file:

- Filters/Statistics/vtkKMeansDistanceFunctor.h